# Copyright (C) 2002-2004 Kouichirou Eto, All rights reserved.

require "singleton"
require "chise/rbchise"

module CHISE
  class ChiseDB
    include Singleton

    def initialize
      @ds = DataSource.new
    end

    def location() @ds.location; end

    def get_feature(f)
      @ds.get_feature(f)
    end

    def get_ccs(c)
      @ds.get_ccs(c)
    end

    def decode_char(name, cid)
      v = @ds.decode_char(name, cid)
      v
    end

    def load_feature(name, cid)
      v = @ds.load_feature(name, cid)
      v = normalize_value(v)
      v
    end

    def each_feature
      @ds.each_feature {|f|
	yield f
      }
    end

    private

    def normalize_value(v)
      return v if v.nil?
      return v.to_i if /\A\d+\Z/ =~ v # number?
      return $1 if /\A"(.+)"\Z/ =~ v # remove surrounding "
      #return v.sub(/\A\?/, "") if v =~ /\A\?/ # remove ? in the head
      #return parse_sexp(v) if v =~ /\A\(.+\)\Z/ # parse sexp # not yet
      v
    end
  end
end
