#!/usr/bin/env ruby
# Copyright (C) 2002-2004 Kouichirou Eto, All rights reserved.

$LOAD_PATH.unshift("..")
require "find"
require "pathname"
require "fileutils"
require "chise/util"

def usage()
  print "Usage: make-chisedb-tarball.rb <directory of XEmacs CHISE> <tmp dir>\n"
  print "% ./make-chisedb-tarball.rb /usr/local/lib/xemacs-21.4.14/i686-pc-linux /var/tmp\n"
  exit
end

def main(argv)
  usage if argv.length < 1
  dir = argv.shift
  path = dir.path
  dbpath = dir+"chise-db"
  unless dbpath.directory?
    print "no chise-db here. #{dbpath.to_s}\n"
    usage
  end
  tmpdir = argv.shift
  tmpdir = "/var/tmp" if tmpdir.nil?
  tmppath = tmpdir.path

  orgdir = Dir.pwd

  tmppath.chdir {
    system "cp -a #{dir}/chise-db ." # copy all of the chise-db to the dir.

    ".".path.find {|f|
      if f =~ /([*?<>])/ # escape for Windows forbidden characters.
	nf = f.escape_win_filename
	cmd = "mv '#{f}' '#{nf}'"
	#print cmd, "\n"
	system cmd
      end
    }

    system "tar czf chise-db.tar.gz chise-db"
    system "mv chise-db.tar.gz #{orgdir}"
    system "rm -rf #{tmpdir}/chise-db"

  }
end
main(ARGV)
